/********************************************
 *   begin options                          *
 ********************************************/
/*	Debugmodus? (=Debug Ausgaben compilieren)	*/
#define	DEBUG						OFF
/*	Debuglogbuch-Datei erstellen? (=Alle Debug Ausgaben in diese Datei)	*/
#define	DEBUG_LOG				OFF

/*	Sprache des Programms (fr Text-Strings im Programmcode)	*/
#define	LANGUAGE				GERMAN

/*	Programm nur unter MagiC lauffhig? (MagiC spez. Funktionen Benutzen?)	*/
#define	MAGIC_ONLY				NO

/*	VDI Workstation initialisieren?	*/
#define	USE_VDI					YES
/*	Farbpalette speichern?	*/
#define	SAVE_COLORS				NO

/*	Beim Schliessen eines Fensters (Dialog/Fenster) werden alle Strukturen 
	aus dem Speicher entfert	*/
#define	WIND_CLOSE_IS_REMOVE	NO
#define	DIAL_CLOSE_IS_REMOVE	NO

/*	Eigene Globale Tastaturkombinationen? (=bentigt DoUserKeybd())	*/
#define	USE_GLOBAL_KEYBOARD	YES

/*	Eigene Events abfangen?	*/
#define	USE_USER_EVENTS		NO

/*	Menzeile installieren? (Bentigt eine Resource MENU)	*/
#define	USE_MENU					YES

/*	Fenster-Dialoge verwenden? (Dank WDialog)	*/
#define	USE_DIALOG				YES
/*	Normale Fenster verwenden?	*/
#define	USE_WINDOW				NO
/*	Fenster-Dateiselektor verwenden?	*/
#define	USE_FILESELECTOR		YES
/*	Fenster-Fontselektor verwenden?	*/
#define	USE_FONTSELECTOR		YES

/*	AV-Protokoll Untersttzung: 
		0	= deaktiviert
		1	= minimal (nur VA_START,AV_SENDCLICK und AV_SENDKEY empfangen)
		2	= normal (AV_PROTOKOL,AV_EXIT,VA_PROTOSTATUS,VA_START,
			  AV_SENDCLICK und AV_SENDKEY)
			  Also anmelden und abmelden beim AV-Server!
		3	= vollstndig (Empfang und Versenden aller mglichen Nachrichten)
			  Bentigt die Prozedur DoVA_Message()!
*/
#define	USE_AV_PROTOCOL		1

/*	Atari Drag&Drop Protokoll Untersttzung	*/
#define	USE_DRAGDROP			YES

/*	Langedateinamen aktivieren (=Pdomain(PD_MINT))	*/
#define	USE_LONGFILENAMES		YES

/*	Lange Editfelder (wie sie von MagiC Untersttzt werden)	*/
#define	USE_LONGEDITFIELDS	YES

/*	BubbleGEM Hilfesystem	*/
#define	USE_BUBBLEGEM			YES
/*	ST-Guide Hilfesystem	*/
#define	USE_STGUIDE				YES

/*	Untersttzung fr das Documen-History Protokoll	*/
#define	USE_DOCUMENTHISTORY	YES

/*	Name der Prototypen-Include-Datei angeben	*/
#define	SPEC_DEFINITION_FILE	"DEFS.H"

/*	Programmname "schn"	*/
#define	PROGRAM_NAME			"MagiCCfg"
/*	Programmname in Grossbuchstaben	*/
#define	PROGRAM_UNAME			"MAGICCFG"
/*	Dateiname der Resource-Datei	*/
#define	RESOURCE_FILE			"MAGICCFG.RSC"
/*	Dateiname der Resource-Header-Datei	*/
#define	RESOURCE_HEADER_FILE	"MAGICCFG.H"
/*	Dateiname der BubbleGEM-Hilfedatei	*/
#define	BUBBLEGEM_FILE			"MAGICCFG.BGH"
/*	Dateiname der ST-Guide-Hilfedatei	*/
#define	STGUIDE_FILE			"*:\\MAGICCFG.HYP "

/*	Maximale Zeilenlnge der Konfigurationsdatei	*/
#define	CFG_MAXLINESIZE		80
/*	Soll die Konfigurationsdatei auch im HOME Verzeichnis gesucht werden?	*/
#define	CFG_IN_HOME				NO

/*	Anzahl der mglichen Drag&Drop Formate	*/
#define	MAX_DDFORMAT			8

/*	Anzahl gleichzeitig iconifizierter Fenster	*/
#define	MAX_ICONIFY_PLACE		16
/*	Anzahl der mglichen Rekursions-Ebenen bei Modalen Objekten	*/
#define	MAX_MODALRECURSION	1


/*	Daten fr event_multi	*/
#define EVENTS		MU_MESAG|MU_KEYBD|MU_BUTTON
#define MBCLICKS	2|0x0100
#define MBMASK		3
#define MBSTATE	0
#define MBLOCK1	NULL
#define MBLOCK2	NULL
#define WAIT		0L

/********************************************
 *   end options                            *
 ********************************************/
